unit elmen_;
interface
uses kol,sqLite3Api;

type 
   TTabRec = record
      id: integer;
      Name: String;
      Info: String;
      Pos: Integer;
   end;    
   
   TElRec = record
      id: String;
      Name: String;
      Tab: integer;
      Pos: integer;
      Hash: String;
   end;


//  elmen.dll 
procedure OpenDB(dbname:PChar);
procedure CloseDB; stdcall;
procedure exec(const s:string);
function query(const s:string):pointer;

//     
function TabByEl(name:String):String; //  id   name 
procedure ElInfo(id: String; var i: TElRec); //  id       
procedure TabInfo(name: String; var i: TTabRec); //  name      
procedure MoveEl(id, ToID: String); //  id    ToID
procedure MoveTab(name, ToName: String);//   name    ToName
function findPrevEl(ElID:String): String;  //       ID
function findNextEl(ElID: String): String; //       ID
function findPrevTab(Name:String): String;//       name
function findNextTab(Name:String): String;//       name

implementation

//###############   
var db:Pointer;
procedure OpenDB(dbname:pchar); 
begin
  checkSqliteLoaded;
  sqlite3_open(dbname, db);
end;

procedure CloseDB; 
begin
  sqlite3_close(db);
end;

function empty_callback(user:pointer; ncols:integer; values:ppchar; names:ppchar):integer; cdecl;
begin
   Result := 0;
end;

procedure exec(const s:string);
var
    ErrMsg:PChar;
begin
  sqlite3_exec(db, PChar(s), empty_callback, nil, @ErrMsg);
  {if ErrMsg <> '' then
    MessageBox(0,ErrMsg,'Error!!',MB_OK);}
end;
 
function query(const s:string):pointer;
var
    tail:PChar;
begin
  sqlite3_prepare(db, PChar(s), -1, Result, tail);
end;

// ##########################################################
// ##############    elmen.dll ####################
                             
function TabByEl(name:String):String;
var r: pointer;
begin
   r := query('select groups.name from groups left join elements on groups.id=tab where elements.id= '''+name+'''');
   sqlite3_step(r);
   result:=sqlite3_column_text(r,0);
   sqlite3_finalize(r);
end;

procedure TabInfo(name: String; var i: TTabRec);
var r: pointer;
begin
  i.name:=name; // msgok('info '+i.name);
  r := query('select id,info,pos from groups where name = ''' + i.Name + '''');
  sqlite3_step(r); 
  i.id := sqlite3_column_int(r,0);
  i.info := sqlite3_column_text(r,1);
  i.pos := sqlite3_column_int(r,2);    
  sqlite3_finalize(r);
end;

procedure MoveTab(name, ToName: String);
Var p: string;
    r: pointer;
    oTab,nTab: TTabRec;
    gmax: integer;
begin
  if (Name='') or (ToName='') then exit;
  TabInfo(Name, oTab);
  TabInfo(ToName, nTab);    //msgOk(oTab.name+','+ nTab.Name);
  if (oTab.Pos = 0) or (nTab.Pos=oTab.Pos) then exit;
  if nTab.Pos<1 then nTab.Pos:=1;
  r := query('select MAX(pos) from groups');
  sqlite3_step(r); gmax := sqlite3_column_int(r,0); sqlite3_finalize(r);
  if nTab.Pos>gmax then nTab.Pos:=gmax;
  if nTab.Pos>oTab.Pos then
    exec('UPDATE groups SET pos=pos-1 WHERE pos>'+Int2Str(oTab.Pos)+' and pos<='+Int2Str(nTab.Pos))    
   else 
    exec('UPDATE groups SET pos=pos+1 WHERE pos>='+Int2Str(nTab.Pos)+' and pos<'+Int2Str(oTab.Pos));
  exec('UPDATE groups SET pos='+Int2Str(nTab.Pos)+' WHERE name='''+oTab.name+'''');    
end;

procedure ElInfo(id: String; var i: TElRec);
Var r: pointer;
begin
  r := query('select name,tab,pos from elements where id = ''' + id + '''');
  sqlite3_step(r); 
  i.id:=id;
  i.Name:= sqlite3_column_text(r,0);
  i.tab := sqlite3_column_int(r,1);
  i.pos := sqlite3_column_int(r,2);
  sqlite3_finalize(r);
end;

procedure MoveEl(id, ToID: String);
Var p: string;
    r: pointer;
    oEl, nEl: TElRec;
    elMax: integer;
begin
  if (id='') or (ToID='') then exit;
  ElInfo(id, oEl);
  ElInfo(ToID, nEl);
  if (oEl.Pos = 0) or (nEl.Pos=oEl.Pos) then exit;
  if nEl.Pos<1 then nEl.Pos:=1;
  r := query('select MAX(pos) from elements where tab='+int2str(oEl.Tab));
  sqlite3_step(r); elMax := sqlite3_column_int(r,0); sqlite3_finalize(r);
  if nEl.Pos>elmax then nEl.Pos:=elmax;
  if nEl.Pos>oEl.Pos then
    exec('UPDATE elements SET pos=pos-1 WHERE tab='+int2str(oEl.Tab)+' and pos>'+Int2Str(oEl.Pos)+' and pos<='+Int2Str(nEl.Pos))    
   else 
    exec('UPDATE elements SET pos=pos+1 WHERE tab='+int2str(oEl.Tab)+' and pos>='+Int2Str(nEl.Pos)+' and pos<'+Int2Str(oEl.Pos));
  exec('UPDATE elements SET pos='+Int2Str(nEl.Pos)+' WHERE tab='+int2str(oEl.Tab)+' and id='''+oEl.id+'''');    
end;

function findPrevEl(ElID:String): String;
var r: pointer;
begin
  r := query('select id from elements where tab = (select tab from elements where id=''' + Elid + 
             ''') and pos=(select MAX(pos) from elements where tab = (select tab from elements where id=''' 
             + Elid + ''') and pos<(select pos from elements where id=''' + Elid + '''))');
  sqlite3_step(r); 
  result:=sqlite3_column_text(r,0);
  sqlite3_finalize(r);
end;

function findNextEl(ElID: String): String;
var r: pointer;
begin
  r := query('select id from elements where tab = (select tab from elements where id=''' + 
              Elid + ''') and pos=(select MIN(pos) from elements where tab = (select tab from elements where id=''' + 
              Elid + ''') and pos>(select pos from elements where id=''' + Elid + '''))');
  sqlite3_step(r); 
  result:=sqlite3_column_text(r,0);
  sqlite3_finalize(r);
end;

function findPrevTab(Name:String): String;
var r: pointer;
begin
  r := query('select name from groups where pos=(select MAX(pos) from groups where name<>'''' and pos<(select pos from groups where name=''' + Name +'''))');
  sqlite3_step(r); 
  result:=sqlite3_column_text(r,0);
  sqlite3_finalize(r);
end;

function findNextTab(Name:String): String;
var r: pointer;
begin
  r := query('select name from groups where pos=(select MIN(pos) from groups where name<>'''' and pos>(select pos from groups where name=''' + Name +'''))');
  sqlite3_step(r); 
  result:=sqlite3_column_text(r,0);
  sqlite3_finalize(r); 
end;
 
end.